#
# This file contains configuration settings for the flash upgrade utility.
#
# Although this file _is_ used as a Makefile fragment, it is also by a
# very simple script to autogenerate config.h. So the syntax in this
# file is a very limited subset of the standard Makefile syntax.
#
# Comment lines start with '#'. No indentation allowed.
#
# All configuration settings must start with "CONFIG_" and must not be
# indented.
#
# The configuration symbol name and its associated value is separated
# by '=' without any spaces or other punctuation surrounding it.
#
# String values must be surrounded by double quotes. Boolean values
# are either 'y' or 'n' (case sensitive) without any
# quotation. Integers are expressed using any valid C syntax.

CONFIG_CHIP="at32ap7000"
CONFIG_PIC=n
CONFIG_GC_SECTIONS=y
CONFIG_CFI_FLASH=y
CONFIG_OSC0_HZ=20000000

CONFIG_IMAGE_FILE="u-boot.bin"
CONFIG_FLASH_OFFSET=0x00000000

# Erase timeout in ms
CONFIG_SECTOR_ERASE_TIMEOUT=10000

# Program timeout in us
CONFIG_WORD_PROGRAM_TIMEOUT=200

# This must be enough to contain the programmer itself, including the
# heap and the stack, as well as the image to be programmed.
# malloc() will panic if the heap grows too close to the stack.
CONFIG_RAM_SIZE=0x100000

CONFIG_AT32AP7000=y
CONFIG_ATMEL_USART=y
CONFIG_LOAD_ADDRESS=0x10000000
CONFIG_ENTRY_ADDRESS=0x90000000
CONFIG_FLASH_BASE=0x00000000
