/*
 * Copyright (c) 2008, Atmel Corporation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. The name of ATMEL may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ATMEL ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY AND
 * SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __CHIP_H__
#define __CHIP_H__

#define SM_BASE		((void *)0xfff00000)
#define HSMC_BASE	((void *)0xfff03400)

void enable_hsb_clock(unsigned int id);
void enable_pba_clock(unsigned int id);
void enable_pbb_clock(unsigned int id);

unsigned long get_cpu_clock_rate(void);
unsigned long get_hsb_clock_rate(void);
unsigned long get_pba_clock_rate(void);
unsigned long get_pbb_clock_rate(void);

static inline void enable_hsmc_hclk(void)
{
	enable_hsb_clock(0);
}

static inline void enable_hsmc_pclk(void)
{
	enable_pbb_clock(13);
}

static inline unsigned long get_hsmc_hclk_rate(void)
{
	return get_hsb_clock_rate();
}

int paddr_to_cs(unsigned long paddr);

#endif /* __CHIP_H__ */
