/*
 * Copyright (c) 2008, Atmel Corporation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. The name of ATMEL may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ATMEL ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY AND
 * SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __IO_H__
#define __IO_H__

#include <types.h>

static inline u8 readb(void *p)
{
	return *(volatile u8 *)p;
}

static inline u16 readw(void *p)
{
	return *(volatile u16 *)p;
}

static inline u32 readl(void *p)
{
	return *(volatile u32 *)p;
}

static inline void writeb(u8 val, void *p)
{
	*(volatile u8 *)p = val;
}

static inline void writew(u16 val, void *p)
{
	*(volatile u16 *)p = val;
}

static inline void writel(u32 val, void *p)
{
	*(volatile u32 *)p = val;
}

#define phys_to_cached(__pa)	((void *)((__pa) | 0x80000000))
#define phys_to_uncached(__pa)	((void *)((__pa) | 0xa0000000))
#define virt_to_phys(__va)	((unsigned long)(__va) & 0x1fffffff)

#endif /* __IO_H__ */
