/*
 * Copyright (c) 2008, Atmel Corporation All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * 3. The name of ATMEL may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ATMEL ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE EXPRESSLY AND
 * SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include "sysreg.h"

	.text
	.global	_start
_start:
	mov	r0, 0
	cache	r0[4], 8
	cache	r0[0], 0
	sync	0

	mov	r1, 0
	orh	r1, hi(SYSREG_BIT(GM) | SYSREG_BIT(M0))
	mtsr	SYSREG_SR, r1

	/*
	 * Since we're loaded in RAM, we don't need to relocate the
	 * data section.  However, we do need to zero out the bss and
	 * if we're PIC, we need to relocate the GOT by adding the
	 * difference between the load-time address and the link-time
	 * address.  We're assuming only RELATIVE relocations as we're
	 * not using dynamically linked libraries or anything.
	 */
#ifdef __PIC__
	lddpc	r8, .Llink_addr
	lddpc	r6, .Lgot_addr
.Llink_addr_target:
	rsub	r8, pc
	add	r6, r8
	lddpc	r9, .Lend_got
	add	r9, r8

	cp.w	r6, r9
	breq	2f
	
	mov	r5, r6
1:	ld.w	r10, r5[0]
	add	r10, r8
	st.w	r5[0], r10
	sub	r5, -4
	cp.w	r5, r9
	brlt	1b
2:
#endif /* __PIC__ */

	/* Now, we can use the addressing pseudo-ops freely */
	lda.w	r0, _edata
	lda.w	r1, _end
	sub	r1, r0
	breq	4f

	mov	r2, 0
	mov	r3, 0
3:	st.d	r0++, r2
	sub	r1, 8
	brgt	3b

	/* Let's go */
4:	lda.w	sp, _estack
	call	main

5:	rjmp	5b

#ifdef __PIC__
	.align	2
.Llink_addr:
	.long	.Llink_addr_target
.Lgot_addr:
	.long	_GLOBAL_OFFSET_TABLE_
.Lend_got:
	.long	_egot
#endif
	/* The assembler will dump the constant pool here if necessary */
